
clear all;clc;
addpath('C:/Users/nli/Documents/personal/supSCAD simulation/glmnet_matlab');

load('xtrain2.mat');
load('ytrain.mat');

load('xtest2.mat');
load('ytest.mat');

%%%%%%%%%%%%%%%%%%%%%%%

load('cvytune.mat')
load('cvxtune.mat')

load('cvytune2.mat')
load('cvxtune2.mat')



%tuning lambda
 lam = 2.^linspace(3,-2,6);
 
  
options=glmnetSet();
options.standardize=false;
options.lambda=lam;
options.maxit=2000;
options.mtype = 'grouped'; 

%%%use 1/3 of the training data as tuning%%%
%%%use 1/3 of the training data as tuning%%%
fit = glmnet(cvxtune,cvytune,'multinomial',options);
      
      y_hat = glmnetPredict(fit,cvxtune2,[],'class');
      
      tunerr = sum(y_hat~=repmat(cvytune2,1,length(lam)))/length(cvytune2);
      
  [me,select] = min(tunerr);
lam_select = lam(select);


options.lambda=lam_select;
fit=glmnet(xtrain2,ytrain,'multinomial',options);

ytest_hat=glmnetPredict(fit,xtest2,lam_select,'class');
err = sum(ytest_hat~=ytest)/length(ytest)

% 0.9615
