
clear all;clc;
addpath('C:/Users/nli/Documents/personal/supSCAD simulation/glmnet_matlab');

load('X1.mat');
load('yy1.mat');

load('X2.mat');
load('yy2.mat');

load('X3.mat');
load('yy3.mat');

load('X4.mat');
load('yy4.mat');

load('X5.mat');
load('yy5.mat');

load('xtest.mat');
load('yy6.mat');



%tuning lambda
 lam = 2.^linspace(4,-4,9);
 
 
  
options=glmnetSet();
options.standardize=false;
options.lambda=lam;
options.maxit=1000;


%five-fold cross validation%five-fold cross validation%
%five-fold cross validation%five-fold cross validation%

tunerr = zeros(length(lam),1);
xtrain = [X1;X2;X3;X4;X5];
ytrain = [yy1;yy2;yy3;yy4;yy5];

% min(mean(xtrain, 1))
% max(mean(xtrain, 1))
% 
% min(std(xtrain, 1))
% max(std(xtrain, 1))




    cv=zeros(length(lam),5);
%     size(cv)
    
  for i =1:5 
      s1 = 1+(i-1)*264;
      s2 = i*264;
      cvxtune = xtrain(s1:s2,:);
      cvytune = ytrain(s1:s2,:);
      
      index = zeros(1320,1);
      index(s1:s2) = 1;
      cvxtrain = xtrain(logical(1-index),:);
      cvytrain = ytrain(logical(1-index),:);
      
      fit=glmnet(cvxtrain,cvytrain,'multinomial',options);
      
      y_hat=glmnetPredict(fit,cvxtune,[],'class');
      
      cv(:,i) = sum(y_hat~=repmat(cvytune,1,length(lam)))/length(cvytune);
  end;    

cv_err = mean(cv,2);

[me,select] = min(cv_err);
lam_select = lam(select);


options.lambda=lam_select;
fit=glmnet(xtrain,ytrain,'multinomial',options);

ytest_hat=glmnetPredict(fit,xtest,lam_select,'class');
err = sum(ytest_hat~=yy6)/length(yy6);

err
% 0.37


%bic tuning%bic tuning%bic tuning%bic tuning%
%bic tuning%bic tuning%bic tuning%bic tuning%
%bic tuning%bic tuning%bic tuning%bic tuning%

options=glmnetSet();
options.standardize=false;
options.lambda=lam;
options.maxit=1000;

fit=glmnet(xtrain,ytrain,'multinomial',options);

ptrain_hat=log(glmnetPredict(fit,xtrain,[],'response'));
coef_hat=glmnetPredict(fit,[],[],'coefficients');

bic=zeros(length(lam),1);
K=10;
d=256;
n=length(ytrain);
ytrain2 =( repmat(ytrain,1,K)==repmat(1:K,n,1));


for j = 1:length(lam)
coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),j);
coefs(:,2)=coef_hat{2}(2:(d+1),j);
coefs(:,3)=coef_hat{3}(2:(d+1),j);
coefs(:,4)=coef_hat{4}(2:(d+1),j);
coefs(:,5)=coef_hat{5}(2:(d+1),j);
coefs(:,6)=coef_hat{6}(2:(d+1),j);
coefs(:,7)=coef_hat{7}(2:(d+1),j);
coefs(:,8)=coef_hat{8}(2:(d+1),j);
coefs(:,9)=coef_hat{9}(2:(d+1),j);
coefs(:,10)=coef_hat{10}(2:(d+1),j);
coefs=coefs';
nz=sum(sum(abs(coefs)>1e-4));

bic(j)=-2*sum(sum(ytrain2.*ptrain_hat(:,:,j)))/n+log(n)*nz/n;
end
[me,select]=min(bic);
lam_select=lam(select);


ytest_hat=glmnetPredict(fit,xtest,lam_select,'class');
err = sum(ytest_hat~=yy6)/length(yy6);
%0.37

coefs=glmnetPredict(fit,[],lam_select,'coefficients');

coef=zeros(d,K);
coef(:,1) = coefs{1}(2:(d+1));
coef(:,2) = coefs{2}(2:(d+1));
coef(:,3) = coefs{3}(2:(d+1));
coef(:,4) = coefs{4}(2:(d+1));
coef(:,5) = coefs{5}(2:(d+1));
coef(:,6) = coefs{6}(2:(d+1));
coef(:,7) = coefs{7}(2:(d+1));
coef(:,8) = coefs{8}(2:(d+1));
coef(:,9) = coefs{9}(2:(d+1));
coef(:,10) = coefs{10}(2:(d+1));
coef=coef';

