 function [P,lnL] = lik(xtrain2,ytrain2,B,K,n)
% PURPOSE: Computes value of negative log likelihood function for multinomial logit regression

xb = xtrain2*B;
e_xb = exp(xb);
sum_e_xb = sum(e_xb,2);
P = e_xb./repmat(sum_e_xb,1,K);

lnp = log(P);
contribution = ytrain2 .* lnp;
lnL = - sum(sum(contribution))/n;