

clear all;clc;
addpath('C:/Users/Jean Wu/Dropbox/submission/supSCAD simulation/real data sets/SRBCT');
addpath('C:/tomlab');
startup;


xtrain = dlmread('khan.xtrain');
ytrain = dlmread('khan.ytrain');
xtrain = xtrain';
ytrain=ytrain';

xtest = dlmread('khan.xtest');
xtest = xtest(:,[1,2,4,6,7,8,10,12,14:25]); %remove NA's
xtest = xtest';

ytest = dlmread('khan.ytest');
ytest=ytest';

ntrain=63;
ntest=20;
d=200;
K=4;
ytrain2 =(repmat(ytrain,1,K)==repmat(1:K,ntrain,1));
 
   
%standardization
%RowNum=size(xdata,1);
MeanCol=mean(xtrain,1);
StdCol=std(xtrain,1,1);
xtrain=(xtrain-repmat(MeanCol,ntrain,1))./repmat(StdCol,ntrain,1);
xtest=(xtest-repmat(MeanCol,ntest,1))./repmat(StdCol,ntest,1);   
 
xdata = [xtrain;xtest];
ydata = [ytrain;ytest];

%sort the columns, by a ranking statistic 
[n,p]=size(xtrain);   
Num=zeros(1,p);
Den=zeros(1,p);

   for i=1:K,
       IndexClass=find(ytrain==i);
       MeanClass=mean(xtrain(IndexClass,:),1);
       LengthClass=length(IndexClass);
       Num=Num+MeanClass.^2*LengthClass;
       Den=Den+var(xtrain(IndexClass,:),1)*LengthClass;
   end;
        Statistic=Num./Den;
        [out1, out2]=sort(Statistic);   
          
 %conclusion     
    % columns are sorted in the increasing order of the statistic.
    xdata=xdata(:,out2);
    newdata=xdata(:,[1:100 end-99:end]);
   
  newxtrain=newdata(1:ntrain,:);
  newxtest=newdata(ntrain+1:end,:);

 




% % % % % %L2
Lambda  = 2.^linspace(8,-8,17);

Tunerr = zeros(17,2);
  for l = 1:17
     cv = zeros(1,ntrain);
     for run = 1:ntrain
      tuneindex = run;
      temp = zeros(ntrain, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = newxtrain(logical(1-temp),:);
      cvxtune = newxtrain(logical(temp),:);
     [w, b] = L2MSVM(cvxtrain,cvytrain,Lambda(l));
     ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = (cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end
  


  
  [mn,index] = min(Tunerr(:,2));
    lambda = Tunerr(index,1);%2
  
 [w, b] = L2MSVM(newxtrain,ytrain,lambda);
 ftest = newxtest*w'+ones(ntest,1)*b';
 [fftest,index] = max(ftest,[],2);
  err = sum(ytest~=index)/ntest%0
  MS = sum(max(abs(w))>1e-4)%200
top=sum(max(abs(w(:,1:100)))>1e-4)%100
bottom=sum(max(abs(w(:,101:end)))>1e-4)%100

